package com.ruoyi.cs.mapper;

import java.util.List;
import java.util.Map;

import com.ruoyi.cs.domain.CsResourceOrderApply;
import com.ruoyi.cs.domain.ResourceOrderApplyListVO;
import com.ruoyi.cs.domain.ResourceOrderApplyVO;
import com.ruoyi.cs.domain.dto.*;
import com.ruoyi.cs.domain.vo.*;
import org.apache.ibatis.annotations.Param;

/**
 * 资源、工单申请Mapper接口
 *
 * @author ruoyi
 * @date 2024-04-23
 */
public interface CsResourceOrderApplyMapper
{
    /**
     * 查询资源、工单申请
     *
     * @param applyId 资源、工单申请主键
     * @return 资源、工单申请
     */
    public CsResourceOrderApply selectCsResourceOrderApplyByApplyId(String applyId);

    /**
     * 查询资源、工单申请列表
     *
     * @param csResourceOrderApply 资源、工单申请
     * @return 资源、工单申请集合
     */
    public List<ResourceOrderApplyVO> selectCsResourceOrderApplyList(CsResourceOrderApply csResourceOrderApply);

    /**
     * 新增资源、工单申请
     *
     * @param csResourceOrderApply 资源、工单申请
     * @return 结果
     */
    public int insertCsResourceOrderApply(CsResourceOrderApply csResourceOrderApply);

    /**
     * 修改资源、工单申请
     *
     * @param csResourceOrderApply 资源、工单申请
     * @return 结果
     */
    public int updateCsResourceOrderApply(CsResourceOrderApply csResourceOrderApply);

    /**
     * 删除资源、工单申请
     *
     * @param applyId 资源、工单申请主键
     * @return 结果
     */
    public int deleteCsResourceOrderApplyByApplyId(String applyId);

    /**
     * 批量删除资源、工单申请
     *
     * @param applyIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteCsResourceOrderApplyByApplyIds(String[] applyIds);

    /**
     * 查询资源、工单申请列表
     *
     * @param paramDto 资源、工单申请
     * @return 资源、工单申请集合
     */
    public List<MemberCsResourceOrderApplyVO> selectCsResourceOrderApplyListForMember(MemberResOrderApplyQueryDTO paramDto);

    /**
     * 用户PC——查询我的工单列表
     *
     * @param myOrderQuery 工单
     * @return 资源、工单申请集合
     */
    public List<MemberMyOrderQueryVo> selectMyOrderApplyListForMember(MemberMyOrderQueryDTO myOrderQuery);

    /**
     * xcx——查询资源、工单申请列表
     *
     * @param paramDto 资源、工单申请
     * @return 资源、工单申请集合
     */
    public List<XcxCsOrderApplyVO> selectOrderApplyListForXcx(XcxApprovalListDTO paramDto);

    /**
     * xcx--获取消息列表
     * @param sysUid
     * @return
     */
    public List<XcxCsOrderApplyVO> selectXcxMsgList(Long sysUid);

    /**
     * 查询管理端资源、工单相关统计
     *
     * @param beginAt 开始时间
     * @param endAt 结束时间
     * @return 资源、工单数量集合
     */
    public Map<String,Object> selectResourceOrderStatistics(@Param("beginAt") String beginAt, @Param("endAt") String endAt);


    /**
     * 工单响应时长统计
     *
     * @return 资源、工单数量集合
     */
    public Map<String,Object> getOrderResponseTimeStatistics(Map<String,Object> params);

    /**
     * 近N天工单处理时长
     * @return
     */
    public List<Map<String, Object>> nOrderHandleTime(Map<String,Object> params);

    /**
     * 资源数量对比
     * @return
     */
    public List<Map<String, Object>> getResourcesContrastNumStatistics(Map<String,Object> params);

    /**
     * 工单数量对比
     * @return
     */
    public List<Map<String, Object>> getOrderContrastNumStatistics(Map<String,Object> params);

    /**
     * 获取工单满意度统计
     * @param dto dto
     * @return List<LabelAndValueVO>
     */
    List<LabelAndValueVO> getSatisfactionStatistics(SatisfactionStatisticsDTO dto);

    /**
     * 单位工单提交统计
     * @param dto dto
     * @return  List<LabelAndValueVO>
     */
    List<WorOrderSubmissionStatisticsDTO> getWorOrderSubmissionStatistics(SatisfactionStatisticsDTO dto);

    /**
     * 导出工单
     * @return
     */
    List<CsResourceOrderApply> exportOrderResponseTimeStatistics(SatisfactionStatisticsDTO dto);

    /**
     * List<CsResourceOrderApply>
     * @param dto
     * @return
     */
    List<CsResourceOrderApply> exportWorkOrderProcessingTime(SatisfactionStatisticsDTO dto);

    /**
     * 查询工单列表
     *
     * @param csResourceOrderApply 资源、工单申请
     * @return 资源、工单申请集合
     */
    List<ResourceOrderApplyListVO> selectResourceOrderApplyList(CsResourceOrderApply csResourceOrderApply);

    /**
     * 根据条件查询工单数量
     *
     * @param params
     * @return
     */
    int searchResourceOrderApplyCountByCondition(Map<String,Object> params);

    /**
     * 查询部门列表
     *
     * @return
     */
    List<Map<String,Object>> searchDeptList();

}

